/************************************************************************************/
/*  Program name CAPPOEXT_PURCHASE_ORDER_HEADER.sql                                 */
/*  Creater:  Kenny, Leung (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 16 Jan 2006, Kenny Leung         First created                               */
/************************************************************************************/

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;s
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOEXT_PURCHASE_ORDER_HEADER';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPPO_PURCHASE_ORDER_HEADER.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		PHA.*
	FROM
		PO_HEADERS_ALL		PHA,
		HR_ALL_ORGANIZATION_UNITS	HRO
	WHERE	PHA.ORG_ID	=	HRO.ORGANIZATION_ID
	AND		SUBSTR(HRO.NAME,4,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	SUBSTR(UPPER('&1'), -4);

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
        
        lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
        
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.PO_HEADER_ID||CHR(9)||
                C1.AGENT_ID||CHR(9)||
                C1.TYPE_LOOKUP_CODE||CHR(9)||
                C1.LAST_UPDATE_DATE||CHR(9)||
                C1.LAST_UPDATED_BY||CHR(9)||
                C1.SEGMENT1||CHR(9)||
                C1.SUMMARY_FLAG||CHR(9)||
                C1.ENABLED_FLAG||CHR(9)||
                C1.SEGMENT2||CHR(9)||
                C1.SEGMENT3||CHR(9)||
                C1.SEGMENT4||CHR(9)||
                C1.SEGMENT5||CHR(9)||
                C1.START_DATE_ACTIVE||CHR(9)||
                C1.END_DATE_ACTIVE||CHR(9)||
                C1.LAST_UPDATE_LOGIN||CHR(9)||
                C1.CREATION_DATE||CHR(9)||
                C1.CREATED_BY||CHR(9)||
                C1.VENDOR_ID||CHR(9)||
                C1.VENDOR_SITE_ID||CHR(9)||
                C1.VENDOR_CONTACT_ID||CHR(9)||
                C1.SHIP_TO_LOCATION_ID||CHR(9)||
                C1.BILL_TO_LOCATION_ID||CHR(9)||
                C1.TERMS_ID||CHR(9)||
                C1.SHIP_VIA_LOOKUP_CODE||CHR(9)||
                C1.FOB_LOOKUP_CODE||CHR(9)||
                C1.FREIGHT_TERMS_LOOKUP_CODE||CHR(9)||
                C1.STATUS_LOOKUP_CODE||CHR(9)||
                C1.CURRENCY_CODE||CHR(9)||
                C1.RATE_TYPE||CHR(9)||
                C1.RATE_DATE||CHR(9)||
                C1.RATE||CHR(9)||
                C1.FROM_HEADER_ID||CHR(9)||
                C1.FROM_TYPE_LOOKUP_CODE||CHR(9)||
                C1.START_DATE||CHR(9)||
                C1.END_DATE||CHR(9)||
                C1.BLANKET_TOTAL_AMOUNT||CHR(9)||
                C1.AUTHORIZATION_STATUS||CHR(9)||
                C1.REVISION_NUM||CHR(9)||
                C1.REVISED_DATE||CHR(9)||
                C1.APPROVED_FLAG||CHR(9)||
                C1.APPROVED_DATE||CHR(9)||
                C1.AMOUNT_LIMIT||CHR(9)||
                C1.MIN_RELEASE_AMOUNT||CHR(9)||
                C1.NOTE_TO_AUTHORIZER||CHR(9)||
                C1.NOTE_TO_VENDOR||CHR(9)||
                C1.NOTE_TO_RECEIVER||CHR(9)||
                C1.PRINT_COUNT||CHR(9)||
                C1.PRINTED_DATE||CHR(9)||
                C1.VENDOR_ORDER_NUM||CHR(9)||
                C1.CONFIRMING_ORDER_FLAG||CHR(9)||
                C1.COMMENTS||CHR(9)||
                C1.REPLY_DATE||CHR(9)||
                C1.REPLY_METHOD_LOOKUP_CODE||CHR(9)||
                C1.RFQ_CLOSE_DATE||CHR(9)||
                C1.QUOTE_TYPE_LOOKUP_CODE||CHR(9)||
                C1.QUOTATION_CLASS_CODE||CHR(9)||
                C1.QUOTE_WARNING_DELAY_UNIT||CHR(9)||
                C1.QUOTE_WARNING_DELAY||CHR(9)||
                C1.QUOTE_VENDOR_QUOTE_NUMBER||CHR(9)||
                C1.ACCEPTANCE_REQUIRED_FLAG||CHR(9)||
                C1.ACCEPTANCE_DUE_DATE||CHR(9)||
                C1.CLOSED_DATE||CHR(9)||
                C1.USER_HOLD_FLAG||CHR(9)||
                C1.APPROVAL_REQUIRED_FLAG||CHR(9)||
                C1.CANCEL_FLAG||CHR(9)||
                C1.FIRM_STATUS_LOOKUP_CODE||CHR(9)||
                C1.FIRM_DATE||CHR(9)||
                C1.FROZEN_FLAG||CHR(9)||
                C1.SUPPLY_AGREEMENT_FLAG||CHR(9)||
                C1.EDI_PROCESSED_FLAG||CHR(9)||
                C1.EDI_PROCESSED_STATUS||CHR(9)||
                C1.ATTRIBUTE_CATEGORY||CHR(9)||
                C1.ATTRIBUTE1||CHR(9)||
                C1.ATTRIBUTE2||CHR(9)||
                C1.ATTRIBUTE3||CHR(9)||
                C1.ATTRIBUTE4||CHR(9)||
                C1.ATTRIBUTE5||CHR(9)||
                C1.ATTRIBUTE6||CHR(9)||
                C1.ATTRIBUTE7||CHR(9)||
                C1.ATTRIBUTE8||CHR(9)||
                C1.ATTRIBUTE9||CHR(9)||
                C1.ATTRIBUTE10||CHR(9)||
                C1.ATTRIBUTE11||CHR(9)||
                C1.ATTRIBUTE12||CHR(9)||
                C1.ATTRIBUTE13||CHR(9)||
                C1.ATTRIBUTE14||CHR(9)||
                C1.ATTRIBUTE15||CHR(9)||
                C1.CLOSED_CODE||CHR(9)||
                C1.USSGL_TRANSACTION_CODE||CHR(9)||
                C1.GOVERNMENT_CONTEXT||CHR(9)||
                C1.REQUEST_ID||CHR(9)||
                C1.PROGRAM_APPLICATION_ID||CHR(9)||
                C1.PROGRAM_ID||CHR(9)||
                C1.PROGRAM_UPDATE_DATE||CHR(9)||
                C1.ORG_ID||CHR(9)||
                C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
                C1.GLOBAL_ATTRIBUTE1||CHR(9)||
                C1.GLOBAL_ATTRIBUTE2||CHR(9)||
                C1.GLOBAL_ATTRIBUTE3||CHR(9)||
                C1.GLOBAL_ATTRIBUTE4||CHR(9)||
                C1.GLOBAL_ATTRIBUTE5||CHR(9)||
                C1.GLOBAL_ATTRIBUTE6||CHR(9)||
                C1.GLOBAL_ATTRIBUTE7||CHR(9)||
                C1.GLOBAL_ATTRIBUTE8||CHR(9)||
                C1.GLOBAL_ATTRIBUTE9||CHR(9)||
                C1.GLOBAL_ATTRIBUTE10||CHR(9)||
                C1.GLOBAL_ATTRIBUTE11||CHR(9)||
                C1.GLOBAL_ATTRIBUTE12||CHR(9)||
                C1.GLOBAL_ATTRIBUTE13||CHR(9)||
                C1.GLOBAL_ATTRIBUTE14||CHR(9)||
                C1.GLOBAL_ATTRIBUTE15||CHR(9)||
                C1.GLOBAL_ATTRIBUTE16||CHR(9)||
                C1.GLOBAL_ATTRIBUTE17||CHR(9)||
                C1.GLOBAL_ATTRIBUTE18||CHR(9)||
                C1.GLOBAL_ATTRIBUTE19||CHR(9)||
                C1.GLOBAL_ATTRIBUTE20||CHR(9)||
                C1.INTERFACE_SOURCE_CODE||CHR(9)||
                C1.REFERENCE_NUM||CHR(9)||
                C1.WF_ITEM_TYPE||CHR(9)||
                C1.WF_ITEM_KEY||CHR(9)||
                C1.MRC_RATE_TYPE||CHR(9)||
                C1.MRC_RATE_DATE||CHR(9)||
                C1.MRC_RATE||CHR(9)||
                C1.PCARD_ID||CHR(9)||
                C1.PRICE_UPDATE_TOLERANCE||CHR(9)||
                C1.PAY_ON_CODE||CHR(9)||
                C1.XML_FLAG||CHR(9)||
                C1.XML_SEND_DATE||CHR(9)||
                C1.XML_CHANGE_SEND_DATE||CHR(9)||
                C1.GLOBAL_AGREEMENT_FLAG||CHR(9)||
                C1.CONSIGNED_CONSUMPTION_FLAG||CHR(9)||
                C1.CBC_ACCOUNTING_DATE||CHR(9)||
                C1.CONSUME_REQ_DEMAND_FLAG||CHR(9)||
                C1.CHANGE_REQUESTED_BY
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No PO HEADERS for NGO';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

